<template>
  <q-layout view="hHh lpR fFf" v-scroll="scrolled">
    <q-header>
      <q-toolbar
        elevated
        bordered
        v-bind:class="{ 'shadow-1': shadow }"
        class="bg-white text-primary"
        id="toolbar"
      >
        <q-avatar>
          <img src="/favicon.png" />
        </q-avatar>

        <q-toolbar-title shrink>
          <div class="ellipsis gt-sm">
            ZoomSense
            <small style="font-size: 40%">v{{ version }}</small>
          </div>
        </q-toolbar-title>

        <q-space />

        <q-btn flat round icon="menu" class="xs">
          <q-menu>
            <q-list style="min-width: 100px">
              <q-item clickable v-close-popup to="/about" exact>
                <q-item-section>About</q-item-section>
              </q-item>
              <q-item clickable v-close-popup to="/scheduled" exact>
                <q-item-section>Meetings</q-item-section>
              </q-item>
              <q-separator />
              <q-item
                v-if="this.loggedIn"
                clickable
                v-close-popup
                @click="logOut"
              >
                <q-item-section>Logout</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>

        <q-btn stretch flat label="About" class="ellipsis gt-xs" to="/about" />
        <q-btn
          stretch
          flat
          label="List Meetings"
          class="ellipsis gt-xs"
          to="/"
        />

        <q-btn
          v-if="this.loggedIn && this.isAdmin"
          stretch
          flat
          label="Admin"
          class="ellipsis gt-xs"
          to="/admin"
        />

        <q-btn
          type="a"
          stretch
          flat
          style="position: relative"
          class="ellipsis gt-xs"
          href="http://docs.zoomsense.io"
          target="__blank"
        >
          For Developers
          <!-- <div class="fordev"> -->
          <!-- Got good ideas? Develop with us! -->
          <!-- <md-icon style="color:#D84315">subdirectory_arrow_left</md-icon> -->
          <!-- </div> -->
        </q-btn>

        <q-btn
          stretch
          flat
          type="a"
          label="@zoomsenseio"
          class="ellipsis gt-xs"
          href="https://twitter.com/zoomsenseio"
          target="__blank"
        />

        <!-- <a href="https://twitter.com/zoomsenseio">@zoomsenseio</a> -->
        <q-space class="gt-xs" />

        <span v-if="this.loggedIn" class="gt-xs">
          <q-chip outline color="primary gt-sm">
            <q-avatar size="27px" v-if="this.user.photoURL">
              <img :src="this.user.photoURL" />
            </q-avatar>
            <span>{{ this.user.displayName || "Anonymous User" }}</span>
          </q-chip>
          <q-btn
            stretch
            flat
            href
            label="Logout"
            @click="logOut"
            class="logout-button"
          />
        </span>
        <span v-else>
          <q-btn stretch flat v-on:click="startLogin" class="login-button">{{
            loginString
          }}</q-btn>
        </span>
        <!-- </div> -->
      </q-toolbar>
    </q-header>

    <q-page-container class="q-pa-sm">
      <router-view :user="this.user" :loadingToken="this.loading" />
    </q-page-container>
  </q-layout>
</template>

<script>
import { EventBus } from "@/components/event-bus.js";
import { auth } from "./db";

export default {
  name: "App",
  data() {
    return {
      loggedIn: false,
      isAdmin: false,
      loading: false,
      loggingIn: this.$router.currentRoute.path == "/login",
      user: null,
      drawers: true,
      shadow: false,
      version: process.env.PACKAGE_VERSION,
    };
  },
  methods: {
    scrolled(pos) {
      if (pos > 0) this.shadow = true;
      else this.shadow = false;
    },
    startLogin() {
      this.loggingIn = true;
      window.location = `${process.env.VUE_APP_FB_FUNCTIONS}/requestZoomAuth?return=${process.env.VUE_APP_REDIRECT}`;
    },
    async logOut() {
      this.$cookies.keys().forEach(cookie => this.$cookies.remove(cookie));
      if (this.$router.currentRoute.path != "/") {
        this.$router.push("/");
      }
      await auth.signOut();
      location.reload();
    },
  },
  computed: {
    loginString() {
      return this.loggingIn ? "Logging in..." : "Log in";
    },
  },
  created() {
    // We load until we get the first user state from firebase
    this.$q.loading.show();
    auth.onAuthStateChanged(user => {
      this.$q.loading.hide();
      if (user !== null) {
        EventBus.$emit("logged-in");
      }
    });
  },
  mounted() {
    EventBus.$on("logged-in", async () => {
      this.user = auth.currentUser;
      this.loggingIn = false;
      this.loggedIn = true;
      this.isAdmin = (await auth.currentUser.getIdTokenResult()).claims.admin;
    });
    EventBus.$on("start-login", () => {
      this.loggingIn = true;
      this.startLogin();
    });
    EventBus.$on("start-logout", () => {
      this.logOut();
    });
  },
};
</script>

<style>
/* .login-button {
  background-color: #2E7C5C;
  border: none;
  color: white;
  text-align: center;
  font-weight: bold;
  padding: 5px 5px;
  text-decoration: none;
  display: inline-block;
  font-weight: bold;
} */

/* .logout-button {
  background-color: white;
  border: none;
  color: #2E7C5C;
  text-align: center;
  font-weight: bold;
  padding: 5px 5px;
  display: inline-block;
  font-weight: bold;
} */

.profile {
  border-radius: 50%;
  width: 30px;
}

.fordev {
  position: absolute;
  top: 30px;
  left: -220px;
  color: #d84315;
  width: 300px;
}

.fordev .md-icon {
  -webkit-transform: rotate(-90deg) scaleX(-1);
  transform: rotate(-90deg) scaleX(-1);
  margin-top: -15px;
}

/* .zoomcontent {
  margin-top: 400px;
  border-radius: 8px;
}

.maintitle {
  font-size: 4em;
  line-height: 0.7;
  margin: 20px;
} */

/* .maintitle p {
  font-size: 0.5em;
  margin-top: 0.3em;
} */

/* .md-content {
  padding: 2em;
} */

#app {
  /* font-family: Avenir, Helvetica, Arial, sans-serif; */
  /* -webkit-font-smoothing: antialiased; */
  /* -moz-osx-font-smoothing: grayscale; */
  text-align: center;
  color: #2c3e50;
  /* position: relative; */
}

#nav {
  padding: 1.5em;
  width: 100%;
  top: 0;
  /* color:white; */
  /* background:white; */
}

#nav a {
  font-weight: bold;
  /* color: #2c3e50; */
}

/* #nav a.router-link-exact-active { */
/* color: #42b983; */
/* } */

.home {
  background: white;
}

/* .homex {
  z-index: -1;
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  background-repeat: no-repeat;
  background-position: center 60px;
  height: 800px;
  background-color: white;
  background-size: 1200px;
} */

/* .username p {
  font-size: large;
  font-weight: bold;
  margin-top: -1em;
} */
/* 
.login {
  margin-top: -0.4em;
}
.login md-button {
  margin-top: -0.4em;
} */

@media only screen and (max-width: 400px) {
  .homex {
    background-size: 800px;
    background-position-y: 160px;
    /* padding-top:180px; */
  }

  .fordev {
    display: none;
  }

  .maintitle {
    font-size: 3em;
    margin-top: 0px;
  }

  .zoomcontent {
    margin-top: 250px;
  }

  /* .md-content {
  padding:1em;
  padding-top:.01em;
} */

  /* .md-content h1 {
    margin-bottom: 0px;
  } */
}
</style>
